//
//| 1F_EViewsMT4.mq4                                                                               |
//| ,   ,    EViews                                    |  
//|    :  2011.09.28                                                                       |         
//
//|          1.             |
//|   :                                                                                    |
//|         StepForecast(  )                                   |
//|             NumberBars   EViews                                |
//|          EViews                                                   |
//|      Eviews          ;             |
//|      EViews       4                                          |
//|                                       |
//|          .                                                      |
//|      ,                                         |
//|           :                          |
//|                                                           |
//|         ,          |
//|         ,            |
//
//
#property copyright "   TF "
#property link      "faa1947@mail.ru"
//
//---------------   ---------------------------------------------------
#include <stdlib.mqh>                  //
#include <stderror.mqh>                //    
#include <WinUser32.mqh>               //  Windows 
//
// ----------------   API   EViews --------------------------------------
#import  "kernel32.dll"
   int      WinExec(string NameEx, int dwFlags);
#import
//
//-----------------  -------------------------------------------------------------
extern   int      StepForecast            =  PERIOD_H1;        //      
extern   int      NumberBars              =  101;              // -    
extern   double   MultSE                  =  2;                // -  
//
//-----------------  ----------------------------------------------------------
         int      ErStop                  =  0;                //   
         double   Forecast;
         double   Forecast_SE;
         double   Trend;                                       //  
         double   TrendPrev;                                   //  
         bool     FirstForecast           =  true;             //   

         double   CommonSL                =  0;
         double   CommonTP                =  0;
         double   slip;          
         int      NumberForecast          =  0;                //      
                                                               //    EViews
         int      GetError;//
         int      CountLabel;
//    Start 
int start()                               
{
//
// ----------------   ----------------------------------------------------------
   static   int         prevTF      =  0;
   static   int         prevTF_M1      =  0;
//
// ------------------     1 ------------------------------------------------------
   if (ErStop                    != 0)
   {
      Print("");
      Print("                                 ");
      Print("");      
      return;
   }  
  
   if (iTime(NULL, PERIOD_M1, 1) != prevTF_M1)
   {
      prevTF_M1                  =  iTime(NULL, PERIOD_M1, 1);

      if(Trend                   <  0.0)
      {
         DrawArrow(-Forecast,  119);
         DrawArrow(-(Forecast  +  Forecast_SE),  160);
         DrawArrow(-(Forecast  -  Forecast_SE),  160);  
//         DrawArrow(-(Forecast  +  2*Forecast_SE),  160);
//         DrawArrow(-(Forecast  -  2*Forecast_SE),  160);                  
      }
      else
      {
         DrawArrow(Forecast,  119); 
         DrawArrow(Forecast  +  Forecast_SE,  160);
         DrawArrow(Forecast  -  Forecast_SE,  160);                 
//         DrawArrow(Forecast  +  2*Forecast_SE,  160);
//         DrawArrow(Forecast  -  2*Forecast_SE,  160);       
      }
// --------      
      return;
   }
//  
   if (iTime(NULL, StepForecast, 1)    != prevTF)           //  
   {
      prevTF                     =  iTime(NULL, StepForecast, 1); 
      ReadEViews();
      Enter_1();

      return;      
   }                                            
// -------------------------------------------------------------------------------------------------
          
   return;                             
}        
// --------------------------  Start() -    ----------------------------------
//
//    
int init()                           
{
   int   lastError; 

  // ------     ----------------------------------------------------
   switch(StepForecast)
   {
      case PERIOD_M5:
      case PERIOD_M15:
      case PERIOD_M30:
      case PERIOD_H1:
      case PERIOD_H4:
      case PERIOD_D1:
      case PERIOD_W1:
         break;
      default:
         ErStop                  =  1;

      return;                                   //   
   }
/*
   FileDelete("EViewsForecast.txt");
   lastError               = GetLastError();
   if(lastError            > 1     &&
      lastError            != 4100)             // 4100 -   
   {
      Print(" (",lastError,")    EViewsForecast.txt");
   }
*/
   FileDelete("KOTIR.txt");
   lastError                = GetLastError();
   if(lastError            > 1     &&
      lastError            != 4100)             // 4100 -   
   {
      Print(" (",lastError,")    KOTIR.txt");
   }

   FileDelete("work.wf1");
   lastError                = GetLastError();
   if(lastError            > 1     &&
      lastError            != 4100)             // 4100 -   
   {
      Print(" (",lastError,")    work.wf1");
   }
}                                    //  

//  deinit() 
int deinit()                           
{
   Print(" "); 
   Print("deinit -   ");
   
   if(ErStop            == 1)
   {
      Print(".   - StepForecast = ", StepForecast);
      Print("StepForecast       ");
   }
      
   if(OrdersTotal()     >  0)
   {
      Print("   = ",    OrdersTotal());
   }
   return(0);
}
//    deinit()    
//
//    
//
// -----------------     4  EViews ------------------------------------                                                        
int  ReadEViews()
{
// -------------------   ----------------------------------   
   string   file_kotir;                         //    1

   int      handle;                             //   
   string   fileForecast   =  "EViewsForecast.txt";
   
   int      i;
//---
// --------------     EViews --------------------------
   file_kotir              =  "KOTIR.txt";      //    
// ---------------    ------------------------------------
  
   handle                  = FileOpen(file_kotir,FILE_CSV|FILE_WRITE,',');
   if(handle               < 1)
   {
      Print("    ", 
            file_kotir,
            ".  #", GetLastError());
      return(0);                                //  
    //FileClose(handle);
   }
// -------------   --------------------------------------------
   FileWrite(handle, "DATE",   "kotir");        // 
   for (i   =  NumberBars  -  1; i  >= 0; i--)
   {
      FileWrite(handle,  TimeToStr(iTime(Symbol(),StepForecast,i)), 
                                    iOpen(Symbol(),StepForecast,i));
   }

   FileWrite(handle, " ", 0);             //   
   FileClose(handle);                            //  

   NumberForecast ++;

   Print("");   
   Print("  KOTIR.txt c   = ", 
            NumberBars+1);
   Print(" :   = ",  TimeToStr(iTime(Symbol(),StepForecast,0)),
         ", n = ",                     iOpen(Symbol(),StepForecast,0));             
// -------------------    EViews -------------------------------
   if(IsOptimization()     ||
      IsTesting()          ||
      IsVisualMode())
   {
      string   W_E         =  "G:\Program Files\EViews7\EViews7.exe G:\ProgramEViews\mod2_t";
      WinExec(W_E, 0);                          // "0"     

      handle               =  FileOpen(fileForecast,FILE_CSV|FILE_READ,',');
      i                    =  0;
      while(handle         <  0)                //    
      {
         handle            =  FileOpen(fileForecast,FILE_CSV|FILE_READ,',');  
         i                 =  i  +  1; 
         if(i              >  1000)
         {
            Print("-   EViewsForecast.txt  1000.");
            Print("   .");
            break; 
         }
      }      
      Print("     = ", i);
   }
   else
   {
      WinExec("G:\Program Files\EViews7\EViews7.exe G:\ProgramEViews\mod2_t", 1);
                       //   
      Sleep(10000);                          //  10                  
      handle               =  FileOpen(fileForecast,FILE_CSV|FILE_READ,',');
      i                    =  0;
      while(handle         <  0)                //    
      {
         handle            =  FileOpen(fileForecast,FILE_CSV|FILE_READ,',');  
         i                 =  i  +  1;               
         if(i              >  1000)
         {
            Print("-   EViewsForecast.txt  1000.");
            Print("   .");
            break; 
         }
      }      
      Print("     = ", i);
   }
//
// -------------------     ----------------------------------
   FileReadNumber(handle);                      //   
   FileReadNumber(handle);
   
   FileReadNumber(handle);                      //   
   Forecast                = FileReadNumber(handle);
   FileReadNumber(handle);                      //   
   Forecast_SE             = FileReadNumber(handle);
   FileReadNumber(handle);                      //   
   Trend                   = -FileReadNumber(handle);
      
   if(handle               <  0)
   {
      Print("   ",  
            fileForecast, 
            ",   .  #", 
            GetLastError());
      return(-1);
   }   
//   Print("  ",  
//         fileForecast);               
// ------------------    ---------------------------------------        
// --------------------    --------------------------
// ----------(  . Enter_1)
   if(FirstForecast)
   {
      TrendPrev            =  Trend;            //   
      FirstForecast        =  false;
   } 
   Print("");
   Print("TrendPrev = ",         TrendPrev); 
   Print("     = ",         Trend,
         ", Open = ",            Open[0],
         ",  Forecast = ",       Forecast,
         ", Forecast_SE = ",     Forecast_SE);  
   FileClose(handle);                 

// -------------
   return(0);
}

//-------------    ----------------------------------
//
//
// ---------------------     ------------------------------
void   Enter_1()                              
{
// -------------------   ----------------------------------   
   double   rr;
// -----------------      ----------------------------
/* ---       
   if(TrendPrev *  Trend          <  0.0      &&
      OrdersTotal()              >  0)
   {
      Print("E-1:  ",      OrdersTotal(),   
            " :       ");
      ClosePozition(0);                         //                 
   }
   TrendPrev                         =  Trend;

   if(OrdersTotal()              >  0)          //   
      return;
*/      
   if(OrdersTotal()        >  0)                //   
      ClosePozition(0);                         //                 

// ------------------  1   ------------------------------------------
   if(Trend                 >  0.0)
   {
// ----------  SL   -----------------------------------------
      if(Forecast_SE - Ask >= 0.0)
         CommonSL          =  Ask   +  Forecast_SE *  MultSE ;
      else
         CommonSL          =  Ask   +  slip;
         
         CommonSL          =  Ask   +  0.0100;    //   - 
         
// ----------     -----------------------------------------
      if(Forecast_SE - Bid >= 0.0)
         CommonTP          =  Bid   -  Forecast_SE *  MultSE ;
      else
         CommonTP          =  Bid   -  slip;  
              
         CommonTP          =  Bid   -  0.0100;  //    - 

         Open_Ord(1); 

      return;
   }
// ------------------  1   ------------------------------------------
   if(Trend                   <  0.0)   
   {
// ----------  SL   -----------------------------------------
      if(Forecast_SE - Bid >= 0.0)
         CommonSL          =  Bid -  Forecast_SE   *  MultSE ;
      else
         CommonSL          =  Bid   -  slip;
         
         CommonSL          =  Bid   -  0.0100;  //   - 
         
// ----------     -----------------------------------------
      if(Forecast_SE - Ask >= 0.0)
         CommonTP          =  Ask   +  Forecast_SE *  MultSE ;
      else
         CommonTP          =  Ask   +  slip;   
         
         CommonTP          =  Ask   +  0.0100;   //    - 
            
         Open_Ord(-1); 

      return;
   }
}
//-------------      ---------------------------------

//
//|   ClosePozition.mqh                                                       |
// ----------------------------------------------------------------------------
int ClosePozition(int NumberEnter)              //  
{
   int      Tip,  err;                          //  
   int      Ticket;                    
   int      Total;                              // - 
   int      i,    ii;
   double   Lot      =  0.0;                    //  . 
   double   Price_Cls,                          //   
            Profit;
   int      NumberOfPoz,                        //   
            magic,                              //   
            slip     =  3,                      //        
            freez; 
   string   Symb        =  Symbol();            
   string   comm,
            Text;
// ----------------------------------------------------------------------------

   Total             =  OrdersTotal();          // - 
   if(Total          == 0)
      {
         Print("   ");
         return(0);
      }
   NumberOfPoz       =  0;
// ---------     ----------------------------------------
   while (!IsTradeAllowed())
   { 
      Sleep(5000);
   }
   if(NumberEnter          <  0)
      Text                 =  " ";
   else
      Text                 =  " ";   
// ---------    -----------------------------------------------
   for(i =  Total -  1; i  >= 0;   i--)         
   {
      if(OrderSelect(i,   SELECT_BY_POS))
      {
         Tip               =  OrderType();
         Ticket            =  OrderTicket();
         Lot               =  OrderLots();
         Lot               =  NormalizeDouble(Lot,  1); 
         comm              =  OrderComment();
         Profit            =  OrderProfit();         
         magic             =  OrderMagicNumber();

         if(Tip            == OP_BUY)
         {
            if(NumberEnter    <  -99            ||    //   
               magic          == NumberEnter    ||    //    
        //       Profit         <  0.0            ||
               NumberEnter    == 0)                   //   
            {

               RefreshRates(); 
               Price_Cls      =  NormalizeDouble(Bid,  Digits); 

               Print("");
               Print(" ", comm);

               if(!OrderClose(Ticket,   Lot,  Price_Cls,  MarketInfo(Symb,MODE_STOPLEVEL), Aqua))
               {                  

                  Print(".. ",  comm,
                        ", price = ",     Price_Cls,
                        ", slippage =",   MarketInfo(Symb,MODE_STOPLEVEL) );
                  continue;
               }
               else
               {
                  Print("  ", comm);
                  NumberOfPoz++;
               }   
               continue;                    
            }
         }      
         if(Tip               == OP_SELL)
         {
            if(NumberEnter    >  99             ||    //   
               magic          == NumberEnter    ||    //    
//               Profit         <  0.0            ||
               NumberEnter    == 0)                   //   
            {

               RefreshRates(); 
               Price_Cls      =  NormalizeDouble(Ask,  Digits); 
               
               Print("");
               Print(" ", comm);

               if(!OrderClose(Ticket,   Lot,  Price_Cls,  MarketInfo(Symb,MODE_STOPLEVEL), Red))
               {                  
                  Print(".. ",  comm,
                        ", price = ",     Price_Cls,
                        ", slippage =",   MarketInfo(Symb,MODE_STOPLEVEL) );
                  continue;
               }
               else
               {
                  NumberOfPoz++;
                  Print("  ", comm);
               }
               continue;                     
            }
         }
      }
   } 
   return(0);                                   //  
}
//
//
// --------------------    --------------------------------
int Open_Ord(int  op)
{
   int      Ticket,                             //  
            errors,
            StopLevel,
            i;
   int      MagicNum;                           // MagicNumber
   double   slip;                               //   = 
            
   double   r_lots,                             //  
            price;
   string   sy       =  Symbol(); 
   int      Total    =  OrdersTotal(),          // - 
            slippage =  MarketInfo(Symbol(),MODE_SPREAD)   +  1;
   string   comm,
            TextOp,
            TextAccount,
            Enter,
            TextEnter,
            TextPrice,
            TextTime; 
// ------------------     ------------------------
   MagicNum                   =  op;   

   if(op                      >  0)
   { 
      TextOp                  =  "Sell";
      TextPrice               =  DoubleToStr(Bid, Digits);
   }
   else
   {
      TextOp                  =  "Buy";
      TextPrice               =  DoubleToStr(Ask, Digits);
   }          
     TextEnter                =  "";

   if(op                      == 1        ||
      op                      == -1)
   {   
      Enter                   =  "1:";
      TextEnter               =  "_H1";   
   }
   if(IsDemo())
      TextAccount             =  "Demo";
   else  
      TextAccount             =  "Real"; 
   TextTime                   =  TimeToStr(TimeCurrent(), TIME_MINUTES);

   comm                       =  Enter                         +
                                 TextOp                        +
                                 TextAccount                   +
                                 ": "                          +  
                                 TextEnter                     +
                                 "="                           +
                                 TextPrice                     +
                                 " "                           +
                                 TextTime;
//
// ------------      5  ----------------------------
   while (!IsTradeAllowed())
   { 
      Sleep(5000);
   }
   RefreshRates();    
// --------------   -------------------------------------------------
   r_lots                  =  0.1;
   CommonSL                =  NormalizeDouble(CommonSL,  Digits);    
   CommonTP                =  NormalizeDouble(CommonTP,  Digits); 
   slippage                =  NormalizeDouble(slippage,  Digits); 
//
// --------------------   ------------------------------------------
   if (op                  <  0)                //    - Buy
   {
      RefreshRates();                           //   
      price                =  NormalizeDouble(Ask, Digits);             
      Print("");  
      Print(" ", comm); 
      Ticket               =  OrderSend(sy,  OP_BUY,
                                 r_lots,        // - 
                                 price,         //    
                                 slippage,      //    
                                 CommonSL,      // 
                                 CommonTP,      // 
                                 comm,          // 
                                 MagicNum,      //   -   
                                 0,             //   
                                 Green);
   }
//
// -------------------   -------------------------------------------
   if (op                  >  0)                                    
   {
      RefreshRates();                           //   
      price                =  NormalizeDouble(Bid, Digits);   
      Print("");
      Print(" ", comm);       
      Ticket               =  OrderSend(  sy,  OP_SELL, 
                                    r_lots,     // -    
                                    price,      //      
                                    slippage,   //    
                                    CommonSL,   // 
                                    CommonTP,   // 
                                    comm,       // 
                                    MagicNum,   //   -   
                                    0,          //   
                                    Red);       //    
   }
//
      
//-----------  --------------------------------------
   GetError                =  GetLastError();
   if(GetError             >  1)
   {   
      Print("Open_Ord-: ",          GetError,
            "-",                          ErrorDescription(GetError));  
      Print(". = ",              comm, 
               ", Ask=",                  Ask, 
               ", Bid=",                  Bid, 
               ", r_lots=",               r_lots, 
               ", CommonSL=",             CommonSL, 
               ", CommonTP=",             CommonTP);           
      return(-1);                         
   }
//-----------------------------------------------------------------------------
   return(Ticket);                        //   . 
}
//
//
// ----------------   -----------------------------------------
double  DrawArrow(double  price,   int   lt) 
{
// -----------------    ---------------------------
   double   pr;
 
   pr       =  MathAbs(price);
   pr       =  NormalizeDouble(pr, Digits);
/*   if(ExtDebug)
   {   
      Print(" ");   
      Print("DrawArrow: = ", price);
   }
*/   
   if(price             >  0.0)
   {
      CountLabel        =  CountLabel  +  1;  
      if(ObjectCreate("Hi"   + CountLabel, OBJ_ARROW, 0, Time[0], pr))
      {
         ObjectSet("Hi"   + CountLabel,   OBJPROP_ARROWCODE,   lt);
         ObjectSet("Hi"   + CountLabel,   OBJPROP_COLOR, Red);
      }   
   }
   if(price             <  0.0)
   {
      CountLabel        =  CountLabel  +  1;  
      if(ObjectCreate("Lo"   + CountLabel, OBJ_ARROW, 0, Time[0], pr))
      {
         ObjectSet("Lo"   + CountLabel,   OBJPROP_ARROWCODE,   lt);
         ObjectSet("Lo"   + CountLabel,   OBJPROP_COLOR, Yellow);
      }   
   }
//   Print("DrawArrow: . =",    TimeHour(Time[0]),   
//          ":",                          TimeMinute(Time[0]),
//          ", price=",                   price);
   return(0.0);
}         
//
// -------------------------   ----------------------------------
// 